import type { Authentication, Call, Contract } from './types';
import { Sealer } from '@skyekiwi/crypto';
import { File } from '@skyekiwi/file';
export declare class SContractReader {
    #private;
    constructor(file: File, sealer: Sealer);
    init(): Promise<void>;
    unlockSealer(seed: string): void;
    getContractPublicKey(): Uint8Array;
    decodeCall(call: string): Call;
    encodeCall(call: Call): string;
    static rawEncodeCall(call: Call, sealer?: Sealer, dest?: Uint8Array): string;
    encodeAuth(auth: Authentication): string;
    decodeAuth(authStringRaw: string): Authentication;
    encodeContract(seed: string, contract: Contract): string;
    decodeContract(contractRaw: string): Contract;
    writeState(state: string): void;
    readState(): string;
    writeAuth(auth: Authentication): void;
    revokeAuth(auth: Authentication): void;
    getContractId(): string;
    writeToFile(path: string): Promise<void>;
    forceInject(seed: string, contract: Contract): void;
    getHighLocalCallIndex(): string;
    readContract(): Contract;
}
